OpenTTD Source: MusicSet Struct Reference

OpenTTD Source 15.0-RC2

Public Member Functions | Data Fields
MusicSet Struct Reference

All data of a music set. More...

`#include <base_media_music.h>`

Inheritance diagram for MusicSet:

## Public Member Functions
bool | FillSetDetails (const IniFile &ini, const std::string &path, const std::string &full_filename)
Public Member Functions inherited from BaseSet< MusicSet >
int | GetNumMissing () const
| Get the number of missing files.
int | GetNumInvalid () const
| Get the number of invalid files.
void | LogError (std::string_view full_filename, std::string_view detail, int level=0) const
| Log error from reading basesets.
const IniItem * | GetMandatoryItem (std::string_view full_filename, const IniGroup &group, std::string_view name) const
| Try to read a single piece of metadata and return nullptr if it doesn't exist.
bool | FillSetDetails (const IniFile &ini, const std::string &path, const std::string &full_filename, bool allow_empty_filename=true)
| Read the set information from a loaded ini.
void | CopyCompatibleConfig (const MusicSet &src)
const std::string & | GetDescription (std::string_view isocode) const
| Get the description for the given ISO code.
std::optional< std::string > | GetTextfile (TextfileType type) const
| Search a textfile file next to this base media.

## Data Fields
MusicSongInfo | songinfo [NUM_SONGS_AVAILABLE]
| Data about individual songs in set.
uint8_t | num_available = 0
| Number of valid songs in set.
Data Fields inherited from BaseSet< MusicSet >
std::string | name
| The name of the base set.
std::string | url
| URL for information about the base set.
TranslatedStrings | description
| Description of the base set.
uint32_t | shortname
| Four letter short variant of the name.
std::vector< uint32_t > | version
| The version of this base set.
bool | fallback
| This set is a fallback set, i.e. it should be used only as last resort.
std::array< MD5File, BaseSet< MusicSet >::NUM_FILES > | files
| All files part of this set.
uint | found_files
| Number of the files that could be found.
uint | valid_files
| Number of the files that could be found and are valid.

## Additional Inherited Members
Public Types inherited from BaseSet< MusicSet >
typedef std::unordered_map< std::string, std::string, StringHash, std::equal_to<> > | TranslatedStrings
Static Public Member Functions inherited from BaseSet< MusicSet >
static MD5File::ChecksumResult | CheckMD5 (const MD5File *file, Subdirectory subdir)
| Calculate and check the MD5 hash of the supplied file.
static std::span< const std::string_view > | GetFilenames ()
| Get the internal names of the files in this set.
Static Public Attributes inherited from BaseSet< MusicSet >
static constexpr size_t | NUM_FILES
| Number of files in this set.
static constexpr bool | SEARCH_IN_TARS
| Whether to search in the tars or not.
static constexpr std::string_view | SET_TYPE
| BaseSet type name.

## Detailed Description

All data of a music set.

Definition at line 53 of file base_media_music.h.

## Member Function Documentation

## ◆ FillSetDetails()

bool MusicSet::FillSetDetails | ( | const IniFile & | ini,
|  | const std::string & | path,
|  | const std::string & | full_filename
| ) |  |

Definition at line 116 of file music.cpp.

## Field Documentation

## ◆ num_available

uint8_t MusicSet::num_available = 0

Number of valid songs in set.

Definition at line 57 of file base_media_music.h.

## ◆ songinfo

MusicSongInfo MusicSet::songinfo[NUM_SONGS_AVAILABLE]

Data about individual songs in set.

Definition at line 55 of file base_media_music.h.

The documentation for this struct was generated from the following files:

- src/base_media_music.h
- src/music.cpp